---
title: SourceBuffer.abort()
slug: Web/API/SourceBuffer/abort
tags:
  - API
  - Audio
  - Experimental
  - MSE
  - Media Source Extensions
  - Method
  - Reference
  - SourceBuffer
  - Video
  - abort
---
<div>{{draft}}{{APIRef("Media Source Extensions")}}{{SeeCompatTable}}</div>

<p>The <code><strong>abort()</strong></code> method of the {{domxref("SourceBuffer")}} interface aborts the current segment and resets the segment parser.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>sourceBuffer</em>.abort();
</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>{{jsxref('undefined')}}.</p>

<h3 id="Exceptions">Exceptions</h3>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Explanation</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>InvalidStateError</code></td>
   <td>The {{domxref("MediaSource.readyState")}} property of the parent media source is not equal to <code>open</code>, or this <code>SourceBuffer</code> has been removed from the {{domxref("MediaSource")}}.</td>
  </tr>
 </tbody>
</table>

<h2 id="Example">Example</h2>

<p>The spec description of <code>abort()</code> is somewhat confusing — consider for example step 1 of <a href="https://w3c.github.io/media-source/index.html#sourcebuffer-reset-parser-state">reset parser state</a>. The MSE API is fully asynchronous, but this step seems to suggest a synchronous (blocking) operation, which doesn't make sense.</p>

<p>Saying that, current implementations can be useful in certain situations, when you want to stop the current append (or whatever) operation occuring on a sourcebuffer, and then immediately start performing operations on it again. For example, consider this code:</p>

<pre class="brush: js">sourceBuffer.addEventListener('updateend', function (_) {
  ...
});

sourceBuffer.appendBuffer(buf);</pre>

<p>Let's say that after the call to <code>appendBuffer</code> BUT before the <code>updateend</code> event fires (i.e. a buffer is being appended but the operation has not yet completed) a user "scrubs" the video seeking to a new point in time.  In this case you would want to manually call <code>abort()</code> on the source buffer to stop the decoding of the current buffer, then fetch and append the newly requested segment that relates to the current new position of the video.</p>

<p>You can see something similar in action in Nick Desaulnier's <a href="https://github.com/nickdesaulniers/netfix/blob/gh-pages/demo/bufferWhenNeeded.html">bufferWhenNeeded demo</a> — in <a href="https://github.com/nickdesaulniers/netfix/blob/gh-pages/demo/bufferWhenNeeded.html#L48">line 48, an event listener is added to the playing video</a> so a function called <code>seek()</code> is run when the <code>seeking</code> event fires. In <a href="https://github.com/nickdesaulniers/netfix/blob/gh-pages/demo/bufferWhenNeeded.html#L92-L101">lines 92-101, the seek() function is defined</a> — note that <code>abort()</code> is called if {{domxref("MediaSource.readyState")}} is set to <code>open</code>, which means that it is ready to receive new source buffers — at this point it is worth aborting the current segment and just getting the one for the new seek position (see <code><a href="https://github.com/nickdesaulniers/netfix/blob/gh-pages/demo/bufferWhenNeeded.html#L78-L90">checkBuffer()</a></code> and <code><a href="https://github.com/nickdesaulniers/netfix/blob/gh-pages/demo/bufferWhenNeeded.html#L103-L105">getCurrentSegment()</a></code>.)</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Media Source Extensions', '#dom-sourcebuffer-abort', 'abort()')}}</td>
   <td>{{Spec2('Media Source Extensions')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.SourceBuffer.abort")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("MediaSource")}}</li>
 <li>{{domxref("SourceBufferList")}}</li>
</ul>
